// pingubot 1.0
// Francisco Reinoso 2011
// http://www.xbot.es/blog/?cat=29


int sd4 = 17; // sensor derecha 4 extremo
int sd3 = 1; // sensor derecha 3
int sd2 = 2; // sensor derecha 2
int sd1 = 3; // sensor derecha 1 central
int si1 = 4; // sensor izquierda 1 central
int si2 = 5; // sensor izquierda 2
int si3 = 6; // sensor izquierda 3
int si4 = 7; // sensor izquierda 4 extremo

int p1 = 13; // pulsador 1
int p2 = 14; // pulsador 2
int i1 = 15; // switch 1
int i2 = 16; // switch 2

int ledrojo = 8; // led rojo
int ledverde = 9; // led verde

int mi_ade = 10; // control de direccion motor izquierdo
int mi_pwm = 11; // control de velocidad motor izquierdo 0-1000

int md_ade = 0;  // control de direccion motor derecho
int md_pwm = 12; // control de velocidad motor derecho 0-1000

int veli = 0; // variable para velocidad motor izquierdo
int veld = 0; // variable para velocidad motor derecho

int marcha = 0; // puesta en marcha o parar sin necesidad de cortar la corriente

void setup()
{

	pinMode(mi_ade,OUTPUT);
	pinMode(md_ade,OUTPUT);
	
	pinMode(sd4,INPUT);
	pinMode(sd3,INPUT);
	pinMode(sd2,INPUT);
	pinMode(sd1,INPUT);
	pinMode(si1,INPUT);
	pinMode(si2,INPUT);
	pinMode(si3,INPUT);
	pinMode(si4,INPUT);
	
	pinMode(p1,INPUT);
	pinMode(p2,INPUT);
	pinMode(i1,INPUT);
	pinMode(i2,INPUT);

	pinMode(ledrojo,OUTPUT);
	pinMode(ledverde,OUTPUT);

	analogWrite(mi_pwm,0);
	analogWrite(md_pwm,0);

}

void Velocidad(int v_i, int v_d)
{
	analogWrite(mi_pwm,v_i);
	analogWrite(md_pwm,v_d);
}


void loop()
{
	
   if (marcha == 1) 
   {

	veli = 600;
	veld = 600;

	delay(1);
	Adelante();

	if (digitalRead(sd2) == HIGH) { veld = 300; }
	if (digitalRead(sd3) == HIGH) { veld = 100; }
	if (digitalRead(sd4) == HIGH) { GiroDerecha(); }

	if (digitalRead(si2) == HIGH) { veli = 300; }
	if (digitalRead(si3) == HIGH) { veli = 100; }
	if (digitalRead(si4) == HIGH) { GiroIzquierda(); }
	
	}
	else
	{
		veli = 0;
		veld = 0;
	}
	Velocidad(veli,veld);

	
	if (digitalRead(p1) == HIGH) 
	{ 
		if (marcha == 0) { marcha = 1; digitalWrite(ledrojo,HIGH); }
		else  { marcha = 0; digitalWrite(ledrojo,LOW); }
		delay(2000);
	} 
	
}


void Parar()
{
	analogWrite(mi_pwm,0);
	analogWrite(md_pwm,0);
}

void Atras()
{
	digitalWrite(mi_ade,HIGH);
	digitalWrite(md_ade,HIGH);
}

void Adelante()
{
	digitalWrite(mi_ade,LOW);
	digitalWrite(md_ade,LOW);
}

void GiroDerecha()
{
	digitalWrite(mi_ade,HIGH);
	digitalWrite(md_ade,LOW);
}

void GiroIzquierda()
{
	digitalWrite(mi_ade,LOW);
	digitalWrite(md_ade,HIGH);
}
